use rand::seq::SliceRandom;

const VALUES: [u8; 13] = [2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14];
const RANKS: [&str; 13] = ["2", "3", "4", "5", "6", "7", "8", "9", "10", "J", "Q", "K", "A"];
const SUITS: [&str; 4] = ["♣", "◆", "♠", "♥"];

#[derive(Debug)]
pub struct Card {
    pub rank: String,
    pub value: u8,
    pub suit: String,
}


#[derive(Debug)]
pub struct Deck {
    pub cards: Vec<Card>,
}

impl Deck {
    pub fn new() -> Deck {
        let mut cards = Vec::new();
        for suit in SUITS.iter() {
            for rank in RANKS.iter() {
                cards.push(Card {
                    rank: rank.to_string(),
                    suit: suit.to_string(),
                    value: VALUES[RANKS.iter().position(|r| r == rank).unwrap()],
                })
            }
        }

        Deck {
            cards,
        }
    }

    pub fn shuffle(&mut self) {
        self.cards.shuffle(&mut rand::rng());
    }
}
