use crate::models::deck::Deck;
use crate::models::hand::Hand;
use crate::models::player::Player;
use std::io;

pub fn game() {
    let mut deck = Deck::new();
    deck.shuffle();

    let mut players: Vec<Player> = Vec::new();
    let mut player_count: String = String::new();

    println!("Welcome to Poker! How many players? (1-4)");
    io::stdin().read_line(&mut player_count).expect("Failed to read line");
    let player_count: usize = player_count.trim().parse().expect("Failed to parse player count");

    for index in 0..player_count {
        players.push(Player {
            name: String::from(format!("Player {}", index + 1)),
            hand: Hand::new(),
        });

        players[index].hand.draw(5, &mut deck);
        players[index].hand.sort_by_value();
    }

    for player in players.iter_mut() {
        println!("{:?}\n", player.name);
    }
}